/****************************************************************************

    Neural Network Library
    Copyright (C) 1999 Filin Alexey

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
    02111-1307, USA.
              
 ****************************************************************************/

// MLPeceptron neuron output functions and them derivatives

#ifndef _MULTI_LAYER_PERCEPTRON_OUT_FUNCTIONS_H_
#  define _MULTI_LAYER_PERCEPTRON_OUT_FUNCTIONS_H_

# include <math.h>
# include "mozg/types.hh"

# define mozgPi 3.1415926535897931

// user defined output function
extern mozgflt mozgweinet (mozgflt net,mozgflt sigm);

// derivative from user defined output function
extern mozgflt mozgDweinet (mozgflt out,mozgflt net,mozgflt sigm);

// user defined output function
extern mozgflt mozgrbfnet (mozgflt net,mozgflt sigm);

// derivative from user defined output function
extern mozgflt mozgDrbfnet (mozgflt out,mozgflt net,mozgflt sigm);

extern mozgflt mozgexp (mozgflt net,mozgflt sigm);

extern mozgflt mozgDexp (mozgflt out,mozgflt net,mozgflt sigm);

extern mozgflt mozgth (mozgflt net,mozgflt sigm);

extern mozgflt mozgDth (mozgflt out,mozgflt net,mozgflt sigm);

extern mozgflt mozglin (mozgflt net,mozgflt sigm);

extern mozgflt mozgDlin (mozgflt out,mozgflt net,mozgflt sigm);

extern mozgflt mozgrbf (mozgflt net,mozgflt sigm);

extern mozgflt mozgDrbf (mozgflt out,mozgflt net,mozgflt sigm);

extern mozgflt mozgatg (mozgflt net,mozgflt sigm);

extern mozgflt mozgDatg (mozgflt out,mozgflt net,mozgflt sigm);

# endif // _MULTI_LAYER_PERCEPTRON_OUT_FUNCTIONS_H_
